/*
 * Linux Ethernet RSTP (IEEE 802.1w) bridging implementation
 * Copyright (C) 2003-2004 IMMS gGmbH, <http://www.imms.de/>
 *
 * Authors:
 * Marco Goetze, <marco.goetze@imms.de>
 *
 * This code builds upon parts of the original STP bridging implementation by
 * Lennert Buytenhek, <buytenh@gnu.org>.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */

#ifndef _BR_RSTP_H
#define _BR_RSTP_H

#include "br_private.h"

/* br_rstp.c */
extern void br_dump_bridge_id(bridge_id*);
extern void br_dump_priority_vector(struct net_bridge_priority_vector*);
extern struct net_bridge_port *br_get_port_by_port_no(struct net_bridge*, int);
extern struct net_bridge_port *br_get_port_by_portId(struct net_bridge*, port_id);
extern int br_stp_compare_priority_vectors(struct net_bridge_priority_vector*,
                                           struct net_bridge_priority_vector*,
                                           int);
extern int br_stp_compare_times(struct net_bridge_times*,
                                struct net_bridge_times*);
extern void br_stp_send_bpdu(struct net_bridge_port*, struct net_bridge_bpdu*);
extern void br_stp_handle_bpdu(struct sk_buff*);
extern void br_tick(unsigned long);

/* br_rstp_if.c */
extern struct net_bridge_port *br_get_port(struct net_bridge*, int);
extern void br_init_bridge(struct net_bridge*);
extern void br_init_port(struct net_bridge_port*);
extern void br_stp_disable_bridge(struct net_bridge*);
extern void br_stp_disable_port(struct net_bridge_port*);
extern void br_stp_enable_bridge(struct net_bridge*);
extern void br_stp_enable_port(struct net_bridge_port*);
extern void br_stp_recalculate_bridge_id(struct net_bridge*);
extern void br_stp_set_bridge_priority(struct net_bridge*, int);
extern void br_stp_set_port_priority(struct net_bridge_port*, int);
extern void br_stp_set_path_cost(struct net_bridge_port*, int);
extern void br_stp_transmit_bpdu(struct net_bridge_port*,
                                 unsigned char*,
                                 int);

#endif  /* _BR_RSTP_H */
